// Arduino f-metr
// выход Т2 (pin D3) и вход Т0 (pin D4)- соединены перемычкой

#include<LiquidCrystal.h>

#define Rst 7                           // pin сброса внешнего счетчика
 
  byte Kg = 8;                          // Коэффициент деления счетчика на входе
  byte b;                               // показания счетчика
  unsigned long f = 0;                  // частота (Гц)
  unsigned int count;                   // cчетчик переполнения Т1
  int Kk = 0;                           // коэффициент коррекции на 16 МГц
  const String del = "      ";          // очистка части дисплея
  boolean Flag1;                        // флаг отображения 1 строки

LiquidCrystal lcd(14,15,16,17,18,19);   // используем аналоговые pin'ы А0-А5

void setup() {
      pinMode(3, OUTPUT);               // выход Т2 - pin 3
      pinMode(4, INPUT);                // вход Т0 - pin 4
      pinMode(6, OUTPUT);               // выход T0 - pin 6
      pinMode(5, INPUT);                // вход T1 - pin 5
          pinMode(8, INPUT); 
          pinMode(9, INPUT); 
          pinMode(10, INPUT); 
        pinMode(Rst, OUTPUT);           // pin сброса счетчика на входе
   
// ----------------Инициализация LCD ---------------------
  lcd.begin(16,2);
  lcd.setCursor(0,0); lcd.print(" ARDUINO f-metr");      
// ---------------  -------------------------

noInterrupts();     
            // таймер 2 - 250 Гц
    OCR2A = 249;
    OCR2B = 125;
    TCCR2A = 0; TCCR2B = 0;  
    TCCR2A = _BV(COM2B1) | _BV(COM2B0) | _BV(WGM21) | _BV(WGM20);  // режим быстрого ШИМ с верхним пределом
    TCCR2B = _BV(WGM22) | _BV(CS22) | _BV(CS21);                   // установка предделителя в 256 и запуск таймера
  
            // таймер 0 выход - 1 Гц
    OCR0A = 249;
    TCCR0A = 0; TCCR0B = 0;
    TCCR0A = _BV(COM0A1) | _BV(WGM00) | _BV(WGM01);                 //  режим ШИМ
    TCCR0B = _BV(CS02) | _BV(CS01);                                
    
            // таймер 1 - счетчик, вход - pin D5
    TCCR1A = 0; TCCR1B = 0; TCNT1 = 0;
    TCCR1B = _BV(CS12) | _BV(CS11) | _BV(CS10) ; 
      TIFR1 = 1 << TOV1;

interrupts();                         // включить глобальные прерывания
}
                  // вывод на экран
void my1LCD () {                                  // 1 строка
          float ff;                                     // частота в МГц (кГц)
       lcd.setCursor(4,0); lcd.print(del + del);
       lcd.setCursor(0,0); lcd.print("f = ");
       if(f < 1000) {
          lcd.print(f); lcd.print(" Hz");}
       else {
          if(f >= 1000000){
              ff = (float)f/1000000.0;
            lcd.print(ff,6); lcd.print(" MHz");}
          else {
              ff = (float)f/1000.0;
            lcd.print(ff,3); lcd.print(" kHz");}
       }
}
void my2LCD () {                                        // 2 строка
       String str1 = del;
         lcd.setCursor(0,1);lcd.print(str1);              
              str1 = " 1s  "; 
          lcd.setCursor(0,1); lcd.print(str1);
}

void corr() {                   //---- расчет коррекции ----
    unsigned long calc_Kk;        
    if (f > 1000) {                     // если > 1 кГц, то корректируем
          calc_Kk = f/1000;             //  частота в кГц       
            calc_Kk *= (Kk);            //  умножаем на Kk     |16 МГЦ - Kk       
              calc_Kk /= 16;            //  делим на 16 кГц    | f МГц - х
              calc_Kk /= 1000;
       f += calc_Kk;                    // корректируем
    }
}

void freq_calc() {              //---- расчет частоты ------
    f = (unsigned long)count * 65536 + TCNT1; 
       f *= (Kg);                                 // умножаем на коэффициент деления счетчика на входе
           f += b;                                // добавляем значение счетчика-делителя
              corr();                             // коррекция
}
void pauza () {
  asm("nop"); asm("nop"); asm("nop"); asm("nop"); asm("nop");
  asm("nop"); asm("nop"); asm("nop"); asm("nop"); asm("nop");
}
 
void loop() {                   //---- бесконечный цикл ----
                                           // измерение 
    if (bitRead(PIND, 6)==1) {                         // то же, что digitalRead(6)==1, только за 1 такт
          if (!Flag1) {Flag1 = true;} 
       if(TIFR1 & (1 << TOV1)) {count++; TIFR1 = 1 << TOV1;}  // проверяем переполнение TCNT1
    }
    else {                                // вывод на экран
      if (Flag1) {
          Flag1 = false;  
             if(TIFR1 & (1 << TOV1)) {count++; TIFR1 = 1 << TOV1;}    // на всякий случай
                    b = PINB & B00000111;                   // читаем значения Pin 8,9,10
                digitalWrite(Rst,0);                        // сброс счетчика-делителя
          freq_calc();                                      // определяем частоту
            count = 0; TCNT1 = 0;                           // обнуляем счетные регистры
                digitalWrite(Rst,1);                        // перевод счетчика в режим счета
                    my1LCD();                               // отображаем частоту
                      my2LCD();                             // отоюражаем 2 строку
      }     
   }
              pauza ();                                     // пауза
}
